/**************************************************************

   Program Title:  IMU64X0 Monitor
   
   Program Name:  IMU64X0_Defines.h	   Version: 1.00
   
   Author:  SS	  					   Date:  Feb 21, 2013
   
   Compiled with AVR Studio 4.19.
   
   Copyright 2004-2013, SOC Robotics, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright (C) 2013 by SOC Robotics, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Robotics, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC Robotics, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-robotics.com
 */
/*
 * $Log: IMU64X0_Defines.h,v $
 * Revision 1.00  2013/02/22 SS
 *    Support for ZigBee added
 * Revision 0.55  2007/07/17 16:40:20  SS
 *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
 * Revision 0.52  2005/06/04 18:36:42  SS
 * Preview release
 *
 */
//  Target Processor
//#define   ATMEGA644TARGET
//#define   ATMEGA644PTARGET
#define   ATMEGA1284PTARGET

// Target Wireless
//#define   ANTWIRELESS
#define   ZIGBEEWIRELESS
//#define   MS5611PRESENT


//  EEPROM Definitions
#define   MAJORVER   	 1
#define   MINORVER       00

// Program version
#define    PRODUCTID			0x08   // IMU6410
//#define    PRODUCTID			0x09   // IMU6420
#define    PROGRAMMAJORVER      1
#define    PROGRAMMINORVER      00

// Start logging mode
#define    ONPOWERUP    'o'
#define    NOTONPOWERUP 'n'
#define    UNIQUE		'u'
#define	   INCREMENTAL  'i'
#define	   DOF9			'9'
#define	   DOF10		'1'
#define    EEPROMBASEADDRESS  130
#define    FSYNCMAX		200   // roughly once a sec at 200Hz

// Define target processor clock rate
//#define	 C8MCLOCK
//#define  C10MCLOCK
#define  C11MCLOCK
//#define  C20MCLOCK

#ifdef C8MCLOCK
//  Baud rates for 8MHz
#define  BAUDRATE2400	 204
#define  BAUDRATE4800	 102
#define  BAUDRATE9600    52
#define  BAUDRATE19200	 25
#define  BAUDRATE38400   11
#endif

#ifdef C10MCLOCK
//  Baud rates for 10MHz
#define  BAUDRATE2400	 240
#define  BAUDRATE4800	 120
#define  BAUDRATE9600    60
#define  BAUDRATE19200	 30
#define  BAUDRATE38400   15
#define  BAUDRATE57600   10
#define  BAUDRATE115200   4
#endif

#ifdef C11MCLOCK
//  Baud rates for 11.0592MHz
#define  BAUDRATE9600    71
#define  BAUDRATE19200	 35
#define  BAUDRATE38400   17
#define  BAUDRATE57600   11
#define  BAUDRATE115200   5
#define  BAUDRATE230400   2
#endif

#ifdef C20MCLOCK
//  Baud rates for 20MHz
#define  BAUDRATE2400	 480
#define  BAUDRATE4800	 240
#define  BAUDRATE9600    120
#define  BAUDRATE19200	 60
#define  BAUDRATE38400   31
#endif

// Other definitions
#define  LEEPROM   		 'e'
#define  LAVRFLASH 		 'a'
#define  LFLASH    		 'f'

#define  INTERNALREF11V  '1'
#define  INTERNALREF256V '2'
#define  EXTERNALREF	 'e'

// Accelerometer defines
#define   G2MODE    '2'
#define   G4MODE    '4'
#define   G8MODE    '8'
#define   G16MODE   '6'
#define   RG        'r'
#define   GONLY     'g'
#define   VERBOSE   'v'
#define	  BRIEF		'b'
#define	  NEW		'n'
#define	  OLD		'o'
#define   GREENLED  'g'
#define   REDLED    'r'

// ADXL345 defines
#define	  DEVICEIDADDRESS	   0x00
#define	  TAPTHRESSHOLADDRESS  0x1D
#define	  XAXISOFFSETADDRESS   0x1E
#define	  YAXISOFFSETADDRESS   0x1F
#define	  ZAXISOFFSETADDRESS   0x20
#define   POWERCONTROLADDRESS  0x2D
#define   INTENABLEADDRESS	   0x2E

#define   DATAFORMATADDRESS    0x31

#define   ADXL345XAXIS	  	   0x01
#define   ADXL345YAXIS		   0x02
#define	  ADXL345ZAXIS		   0x03

#define	  XAXISDATA0ADDRESS	   0x32
#define	  XAXISDATA1ADDRESS	   0x33
#define	  YAXISDATA0ADDRESS	   0x34
#define	  YAXISDATA1ADDRESS	   0x35
#define	  ZAXISDATA0ADDRESS	   0x36
#define	  ZAXISDATA1ADDRESS	   0x37

// BMA180 Defines
#define	  BMA180TWIADDRESS	   0x40

// ITG-3200 Define
#define   ITG3200TWIADDRESS    0x69

// L3G4200D defines
#define   L3G4200XAXIS		   0x01
#define   L3G4200YAXIS		   0x02
#define	  L3G4200ZAXIS		   0x03
#define	  WHO_AM_I 			   0x0F
#define	  CTRL_REG1			   0x20
#define	  CTRL_REG2			   0x21
#define	  CTRL_REG3			   0x22
#define	  CTRL_REG4			   0x23
#define	  CTRL_REG5			   0x24
#define	  REF_DATA_CAPTURE	   0x25
#define	  OUT_TEMP			   0x26
#define	  STATUS_REG		   0x27
#define	  OUT_X_L			   0x28
#define	  OUT_X_H			   0x29
#define	  OUT_Y_L			   0x2A
#define	  OUT_Y_H			   0x2B
#define	  OUT_Z_L			   0x2C
#define	  OUT_Z_H			   0x2D
#define	  FIFO_CTRL_REG		   0x2E
#define	  FIFO_SRC_REG		   0x2F
#define	  INT1_CFG			   0x30
#define	  INT1_SRC			   0x31
#define	  INT1_THS_XH		   0x32
#define	  INT1_THS_XL		   0x33
#define	  INT1_THS_YH		   0x34
#define	  INT1_THS_YL		   0x35
#define	  INT1_THS_ZH		   0x36
#define	  INT1_THS_ZL		   0x37
#define	  INT1_DURATION		   0x38
#define   L250DPS			   '2'
#define   L500DPS		   	   '5'
#define   L2000DPS		   	   '9'
#define   L100HZ			   '1'
#define   L200HZ			   '2'
#define   L400HZ			   '4'
#define   L800HZ			   '8'

// HMC5883 definitions
#define  HMC5883TWIADDRESS  0x1E

#define  HMC5883_CONFIG_REGA  0x00
#define  HMC5883_CONFIG_REGB  0x01
#define  HMC5883_MODE_REG	  0x02
#define  HMC5883_CONTINUOUS_M 0x00
#define	 HMC5883_SINGLE_M	  0x01
#define  HMC5883_OUT_X_H	  0x03
#define  HMC5883_OUT_X_L	  0x04
#define  HMC5883_OUT_Y_H	  0x07
#define  HMC5883_OUT_Y_L	  0x08
#define  HMC5883_OUT_Z_H	  0x05
#define  HMC5883_OUT_Z_L	  0x06
#define  HMC5883_STATUS_REG	  0x09
#define  HMC5883_ID_REG_A	  0x10
#define  HMC5883_ID_REG_B	  0x11
#define  HMC5883_ID_REG_C	  0x12
#define  HMC5883_XAXIS 		  'x'
#define  HMC5883_YAXIS	  	  'y'
#define  HMC5883_ZAXIS	  	  'z'

#define  HMC1SAMPLE			  0x00
#define  HMC2SAMPLE			  (1<<5)
#define  HMC4SAMPLE			  (2<<5)
#define  HMC8SAMPLE			  (3<<5)

#define  HMC0075HZ			  0x00
#define  HMC0015HZ			  (1<<2)
#define  HMC0030HZ			  (2<<2)
#define  HMC0750HZ			  (3<<2)
#define  HMC1500HZ			  (4<<2)
#define  HMC3000HZ			  (5<<2)
#define  HMC7500HZ			  (6<<2)

#define  HMCNORMAL			  0x00
#define  HMCPOSITIVE		  0x01
#define  HMCNEGATIVE		  0x02

#define  HMC088GA			  0x00
#define  HMC130GA			  (1<<5)
#define  HMC190GA			  (2<<5)
#define  HMC250GA			  (3<<5)
#define  HMC400GA			  (4<<5)
#define  HMC470GA			  (5<<5)
#define  HMC560GA			  (6<<5)
#define  HMC810GA			  (7<<5)

#define  HMCCONTINUOUS		  0x00
#define  HMCSINGLE			  0x01
#define  HMCIDLE			  0x02

#define  HMCLOCK			  0x02
#define  HMCRDY				  0x01

// Measurement Specialities MS5611 Sensor TWI Address
#define  MS5611TWIADDRESS   0x76
#define  MS5611_RESET	    0x1E
#define	 MS5611_CONVERTD10	0x40
#define	 MS5611_CONVERTD11	0x42
#define  MS5611_CONVERTD12	0x44
#define  MS5611_CONVERTD13	0x46
#define  MS5611_CONVERTD14	0x48
#define  MS5611_CONVERTD20  0x50
#define  MS5611_CONVERTD21  0x52
#define  MS5611_CONVERTD22  0x54
#define  MS5611_CONVERTD23  0x56
#define  MS5611_CONVERTD24  0x58
#define  MS5611_ADC		    0x00
#define  MS5611_PROM		0xA0

// Bosch BMP085 Sensor TWI Address
#define  BMP085TWIADDRESS  0x77
#define  BMPSENSOR1		   '1'  // Ambient pressure sensor
#define	 BMPSENSOR2		   '2'  // Chamber pressure sensor
#define	 BMPTEMP		   't'
#define  BMPPRESSURE	   'p'
#define  BMPTEMPIDLE	   'i'
#define  BMPTEMPREAD	   'r'
#define  BMPPRESSUREREAD   'r'
#define  BMPPRESSUREIDLE   'i'
#define  BMPSKIPVALUE		6

// Serial Flash
#define	 FLASHBYTESPERPAGE 256
#define  SF_READ_CONT	 0xE8
#define  SF_READ_BUFFER1 0x54
#define  SF_READ_BUFFER2 0x56
#define  SF_WRITE_BUFFER1 0x84
#define  SF_WRITE_BUFFER2 0x87
#define  SF_BUF1_TO_FLASH_ERASE 0x83
#define  SF_BUF2_TO_FLASH_ERASE 0x86
#define  SF_BUF1_TO_FLASH_NOERASE 0x88
#define  SF_BUF2_TO_FLASH_NOERASE 0x89
#define  SF_FLASH_TO_BUF1 0x53
#define  SF_FLASH_TO_BUF2 0x55
#define  SF_PAGE_ERASE	  0x81
#define  SF_CHIP_ERASE1	  0xC7
#define  SF_CHIP_ERASE2	  0x94
#define  SF_CHIP_ERASE3	  0x80
#define  SF_CHIP_ERASE4	  0x9A
#define  SF_BLOCK_ERASE	  0x50
#define  SF_READ_STATUS	  0xD7
#define	 HIGH		     1
#define	 LOW			 2
#define  READCONTINUOUS  1
#define  READBUFFER      2
#define	 AT45DB041ID  	 0x1C
#define	 AT45DB081ID  	 0x24
#define	 AT45DB161ID  	 0x2C
#define	 AT45DB321ID  	 0x34
#define	 AT45DB642ID  	 0x3C
#define  FLASHIDMASK	 0x3C
#define  FLASHCHIP_1	 1

// Logging commands
#define  START	   		 's'
#define	 HALT			 'h'
#define  RAW			 'r'
#define  PROCESSED		 'p'
#define  MINMAX			 'm'
#define  BUTTON			 'b'
#define  TIMEOUT		 't'
#define  CALIBRATE		 'c'
#define  CHANGESPEED	 's'
#define  CHANGERANGE 	 'g'
#define  LEFTARM		 'l'
#define  RIGHTARM		 'r'
#define	 UPPERSPINE		 'u'
#define  LOWERSPINE		 'l'
#define  SLED			 's'
#define  DISABLED		 'd'

// LCD Color Switch
#define  SWITCH1         0x01
#define  SWITCH2		 0x02
#define  SWITCH3		 0x04
#define  SWITCH4		 0x08
#define  SWITCH5		 0x10
#define  SWITCH6 		 0x20
#define  SWITCH7		 0x40
#define  SWITCH_RIGHT    0x01
#define  SWITCH_CENTER 	 0x04
#define  SWITCH_MIDRIGHT 0x10
#define  SWITCH_UP		 0x08
#define  SWITCH_MIDLEFT	 0x40
#define  SWITCH_DOWN	 0x20
#define  SWITCH_LEFT     0x02

// Misc defines
#define   NO  		  	 0x00
#define   YES 		  	 0x01
#define   ON  		  	 0x00
#define   OFF 		  	 0x01
#define   DEBUG 		  0
#define   PI			  3.14159265

// ADS1100 definitions
#define  ADS1100ADDRESS  0x48
//#define  ADS1100ADDRESS  0x4A
#define  ADS1100ADDRESSWR  0x92
#define  ADS1100ADDRESSRD  0x93

// SmartLCD definitions
#define  SMARTLCDTWIADDRESS  0x26

// Digital Compass definitions
#define  DIGITALCOMPASSTWIADDRESS 0x21

// MM130 TWI Address
#define  MM130TWIADDRESS  0x14

// WIP parameters
#define  RIGHT	 		  'r'
#define	 LEFT			  'l'
#define	 HOME			  'h'

//  Digital Caliper TWI Address
#define  ATTINY85ADDRESS   0x10

// TWI definitions
#define   TWI_SLAVEADDRESS  0x08
#define   TWI_MASTERADDRESS 0x09
#define   TWIMESSAGELENGTH  21
#define	  ACTIVE            'a'
#define   INACTIVE          'i'
#define   TWI_GENERAL_CALL_ON  1
#define   TWI_START   		0x08
#define   TWI_STOP    		0xA0
#define   MT_SLA_ACK  		0x18
#define   MT_DATA_ACK 		0x28
#define   SR_WRITE_COMMAND  0x60
#define   SR_READ_COMMAND   0xA8
#define   SLA_W		  	    0x00
#define   SLA_R		  	    0x01
#define	  QUIET				1

// Motor control functions
#define  LEFTWHEEL     'l'
#define  RIGHTWHEEL    'r'
#define  FULLSTEP	   'f'
#define  HALFSTEP	   'h'
#define  QUARTERSTEP   'q'
#define  EIGTHSTEP	   '8'
#define  SIXTEENTHSTEP '6'

// Data logger
#define	SERIALFLASH   's'
#define MICROSD		  'm'

// Delayed time
typedef struct {
	volatile int day;
	volatile int hour;
	volatile int minute;
	volatile int second;
} delay_time ;

// Bit twiddling
#define SetBit(x,y) (x|=(1<<y)) 
#define ClrBit(x,y) (x&=~(1<<y)) 
#define ToggleBit(x,y) (x^=(1<<y)) 
#define FlipBit(x,y) (x^=(1<<y)) // Same as ToggleBit.  
#define TestBit(x,y) (x&(1<<y)) 

#define BIT(x) (1<<x)

